/*
 * ----------------------------------------------------------------------------
 * "THE BEER-WARE LICENSE" (Revision 42):
 * <csjp@sqrt.ca> wrote this file.  As long as you retain this notice you
 * can do whatever you want with this stuff. If we meet some day, and you think
 * this stuff is worth it, you can buy me a beer in return. Christian SJ Peron
 * ----------------------------------------------------------------------------
 *
 */
#ifndef	__RDWRLOCK_DOT_H__
#define	__RDWRLOCK_DOT_H__

#include <pthread.h>

struct rdwrlock {
	pthread_mutex_t		lock;
	int			rwlock;
	pthread_cond_t		rdsok;
	int		nwrs_wait;
	pthread_cond_t		wrok;
	pthread_t		thrid;
};
#define	M_OWNED		0x0000001U
#define	M_NOTOWNED	0x0000002U
#define	WRLOCK_ASSERT(what, thread) do {				\
	pthread_t me;							\
	me = pthread_self();						\
	if (what == M_OWNED)						\
		assert((thread)->thrid == me);				\
	else if (what == M_NOTOWNED)					\
		assert((thread)->thrid != me);				\
} while (0)
void rdwr_lock_init(struct rdwrlock *);
void rd_lock(struct rdwrlock *);
void wr_lock(struct rdwrlock *);
void rdwr_unlock(struct rdwrlock *);
#endif	/* __RDWRLOCK_DOT_H__ */
