/*
 * ----------------------------------------------------------------------------
 * "THE BEER-WARE LICENSE" (Revision 42):
 * <csjp@sqrt.ca> wrote this file.  As long as you retain this notice you
 * can do whatever you want with this stuff. If we meet some day, and you think
 * this stuff is worth it, you can buy me a beer in return. Christian SJ Peron
 * ----------------------------------------------------------------------------
 *
 */
#ifndef	_TERMLOG_DOT_H_
#define _TERMLOG_DOT_H_

#define DEFAULT_LINE_BUFSIZE	1024U
#define	MAXUSERS	10U
#define	MAXTTYS		10U

#define	DEBUG_LOCKS
#define	TERMLOG_VERSION	"2.0-BETA"
#define _PATH_TERMLOG_STATS	"termlog.stats"
#define	_SNP_MAJOR 53

#include <sys/types.h>
#include <sys/queue.h>
#ifndef DEBUGGING
#undef NDEBUG
#endif

#ifndef TAILQ_FOREACH_SAFE
#define TAILQ_FOREACH_SAFE(var, head, field, tvar)                      \
        for ((var) = TAILQ_FIRST((head));                               \
            (var) && ((tvar) = TAILQ_NEXT((var), field), 1);            \
            (var) = (tvar))
#endif
struct snp_d {
	char		s_username[UT_NAMESIZE];
        char		s_line[UT_LINESIZE];
        int		s_fd;
        void	       *s_meta;
	int		(*snp_write)(void *data, char *ptr, int size);
	void	       *(*snp_setup)(void *data, char *config);
	int		(*snp_close)(void *data);
	int		(*snp_overflow)(void *data);
	u_long		s_bytes;
        TAILQ_ENTRY(snp_d) glue;
};
#define	DEBUG(v, fmt, args...)						\
	do {								\
		if (v > 0)						\
			fprintf(stderr, "DEBUG: " fmt "\n", ##args);	\
	} while (0)
int getsnpfd(char **, size_t);
int ttystat(char *, int);
int processutmp(struct stat *);
int linktty(struct utmp *);
int snpattach(char *);
void *watchutmp(void *);
int ttyislinked(struct utmp *);
void usage(char *);
int checkuserlist(struct utmp *);
int checkttylist(struct utmp *);
int skipcrtltty(struct utmp *);
int handlesnpio(struct snp_d *);
int buildfdlist(fd_set *);
void *eventloop(void *);
int dolog(char const *const fmt, ...);

#endif
